/*****************************************************************************/
/*!
    @file     	FMRX.h
    @author   	www.elechouse.com
	@version  	V1.0
	@date		2012-11-1
	@brief    	FMRX demo header file

	@section  HISTORY
	
    V1.0    Initial version.

    Copyright (c) 2012 www.elechouse.com  All right reserved.
*/
/*****************************************************************************/

#ifndef __FMRX_H
#define __FMRX_H

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif
#include "wiring_private.h"


#ifndef __TYPE_REDEFINE
#define __TYPE_REDEFINE
typedef uint8_t u8;
typedef int8_t  s8;
typedef uint16_t u16;
typedef int16_t  s16;
typedef uint32_t u32;
typedef int32_t  s32;
#endif

#ifndef I2C_FREQ
  #define I2C_FREQ 50000L
#endif

//#define __FM_DEBUG
#define __RDA5807_MODE

#ifdef __RDA5807_MODE
#define FMRX_CMD_WRITE      (0x20)
#define FMRX_CMD_READ       (0x21)
#else
#define FMRX_CMD_WRITE      (0xC0)
#define FMRX_CMD_READ       (0xC1)
#endif

#define SEEK_UP             0
#define SEEK_DOWN           1

#define BAND_JP             (0x04)
#define BAND_US             (0x00)
#define BAND_EU             (0x00)
#define BAND_JP_WIDE        (0x08)

void i2c_init(void);
void i2c_stop();
extern u8 fmrx_reg_r[];
extern u8 fmrx_reg_w[];

void fmrx_read_reg(u8 *reg_buf);
void fmrx_write_reg(u8 *reg_buf);
void fmrx_write_byte(u8 reg, u8 dt);
float fmrx_set_freq(float rf_freq);
void fmrx_power(void);
float fmrx_seek(u8 dir);
void fmrx_set_volume(u8 vol);
void fmrx_set_rssi(u8 rssi);
void fmrx_select_band(u8 band);
float fmrx_get_freq();
#endif

